package com.ibm.websphere.fabric.hc.context.extractor;

import com.ibm.websphere.fabric.da.PendingRequest;
import com.ibm.websphere.fabric.da.context.Context;
import com.ibm.websphere.fabric.da.plugin.ContextExtractor;
import com.ibm.websphere.fabric.da.plugin.UnexpectedContentException;
import com.ibm.websphere.fabric.da.types.TypedValue;
import com.ibm.websphere.fabric.hc.util.BPELUtility;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.ws.fabric.da.sca.util.SdoUtil;
import commonj.sdo.DataObject;

public class LOBAssertionPlanTypeContextExtractorImpl implements
		ContextExtractor {

	private static final String LOB_TYPE_ASSERTION_ELEMENT = "http://www.ibm.com/websphere/fabric/healthcare/payor/ext/assertion#lineOfBusiness";

	private static final String FABRIC_GOVERNANCE = "fc://fabric/governance/fabricproject-inst#0dceb16c-bafa-473f-b289-39897c8225a6";

	private static final String FABRIC_GOVERNANCE_VALUE = "http://www.webifysolutions.com/2005/10/catalog/governance#FabricProject";

	/**
	 * Default constructor.
	 */
	public LOBAssertionPlanTypeContextExtractorImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this
	 * implementation class. This method should be used when passing this
	 * service to a partner reference or if you want to invoke this component
	 * service asynchronously.
	 * 
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private ContextExtractor getMyService() {
		return (ContextExtractor) ServiceManager.INSTANCE.locateService("self");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @seecom.ibm.websphere.fabric.da.plugin.ContextExtractor#extractContext(
	 * PendingRequest arg0)
	 */
	public Context extractContext(PendingRequest req)
			throws UnexpectedContentException {
		Context context = req.getContext();

		DataObject object = req.getFirstBodyElement();
		System.out.println("PendingRequest : " + SdoUtil.printTree(object));

		String patientId = object.getDataObject("PatientDetails")
				.getString("patientId");

		TypedValue assertionValue = new TypedValue(BPELUtility
				.getLOBAssertion(patientId));
		context
				.setSelectionProperty(LOB_TYPE_ASSERTION_ELEMENT,
						assertionValue);

		TypedValue governanceFabricProjectValue = new TypedValue(
				FABRIC_GOVERNANCE);

		context.setSelectionProperty(FABRIC_GOVERNANCE_VALUE,
				governanceFabricProjectValue);
		return context;
	}

}